signature AntAsm_TOKENS =
sig
type ('a,'b) token
type svalue
val EOF:  'a * 'a -> (svalue,'a) token
val COLON:  'a * 'a -> (svalue,'a) token
val ASSIGN:  'a * 'a -> (svalue,'a) token
val CASE:  'a * 'a -> (svalue,'a) token
val SWITCH:  'a * 'a -> (svalue,'a) token
val IN:  'a * 'a -> (svalue,'a) token
val OF:  'a * 'a -> (svalue,'a) token
val VARIABLE:  'a * 'a -> (svalue,'a) token
val WHILE:  'a * 'a -> (svalue,'a) token
val REPEAT:  'a * 'a -> (svalue,'a) token
val GOTO:  'a * 'a -> (svalue,'a) token
val END:  'a * 'a -> (svalue,'a) token
val ELSE:  'a * 'a -> (svalue,'a) token
val THEN:  'a * 'a -> (svalue,'a) token
val IF:  'a * 'a -> (svalue,'a) token
val SETNAME:  'a * 'a -> (svalue,'a) token
val ABORT:  'a * 'a -> (svalue,'a) token
val PRINT:  'a * 'a -> (svalue,'a) token
val DEFINE:  'a * 'a -> (svalue,'a) token
val INCLUDE:  'a * 'a -> (svalue,'a) token
val CALL:  'a * 'a -> (svalue,'a) token
val FUNC:  'a * 'a -> (svalue,'a) token
val FLIP:  'a * 'a -> (svalue,'a) token
val MOVE:  'a * 'a -> (svalue,'a) token
val TURN:  'a * 'a -> (svalue,'a) token
val DROP:  'a * 'a -> (svalue,'a) token
val PICKUP:  'a * 'a -> (svalue,'a) token
val UNMARK:  'a * 'a -> (svalue,'a) token
val MARK:  'a * 'a -> (svalue,'a) token
val SENSE:  'a * 'a -> (svalue,'a) token
val SENSING:  'a * 'a -> (svalue,'a) token
val FALSE:  'a * 'a -> (svalue,'a) token
val TRUE:  'a * 'a -> (svalue,'a) token
val NOT:  'a * 'a -> (svalue,'a) token
val SOMEOF:  'a * 'a -> (svalue,'a) token
val ALLOF:  'a * 'a -> (svalue,'a) token
val FOEHOME:  'a * 'a -> (svalue,'a) token
val HOME:  'a * 'a -> (svalue,'a) token
val FOEMARKER:  'a * 'a -> (svalue,'a) token
val MARKER:  'a * 'a -> (svalue,'a) token
val ROCK:  'a * 'a -> (svalue,'a) token
val FOOD:  'a * 'a -> (svalue,'a) token
val FOEWITHFOOD:  'a * 'a -> (svalue,'a) token
val FRIENDWITHFOOD:  'a * 'a -> (svalue,'a) token
val FOE:  'a * 'a -> (svalue,'a) token
val FRIEND:  'a * 'a -> (svalue,'a) token
val RIGHT:  'a * 'a -> (svalue,'a) token
val LEFT:  'a * 'a -> (svalue,'a) token
val RIGHTAHEAD:  'a * 'a -> (svalue,'a) token
val LEFTAHEAD:  'a * 'a -> (svalue,'a) token
val AHEAD:  'a * 'a -> (svalue,'a) token
val HERE:  'a * 'a -> (svalue,'a) token
val COMMA:  'a * 'a -> (svalue,'a) token
val RPAREN:  'a * 'a -> (svalue,'a) token
val LPAREN:  'a * 'a -> (svalue,'a) token
val STRING: (string) *  'a * 'a -> (svalue,'a) token
val NEXT:  'a * 'a -> (svalue,'a) token
val IDENT: (string) *  'a * 'a -> (svalue,'a) token
val NUMBER: (int) *  'a * 'a -> (svalue,'a) token
end
signature AntAsm_LRVALS=
sig
structure Tokens : AntAsm_TOKENS
structure ParserData:PARSER_DATA
sharing type ParserData.Token.token = Tokens.token
sharing type ParserData.svalue = Tokens.svalue
end
