

structure AsmParse = 
  struct

      structure AntAsmLrVals = AntAsmLrValsFun (structure Token = LrParser.Token)
      structure AntAsmLex = AntAsmLexFun (structure Tokens = AntAsmLrVals.Tokens)
      structure AntAsmParser = Join (structure ParserData = AntAsmLrVals.ParserData;
				   structure Lex = AntAsmLex;
				   structure LrParser = LrParser)

      val lookahead = 15 (* Magic number from somewhere *)

      fun invoke infname lexstream =
	let fun print_error (s,i:int,_) =
	  TextIO.output(TextIO.stdOut,
			"Error: " ^ infname ^ ", line " ^ (Int.toString i) ^ ", " ^ s ^ "\n")
	in AntAsmParser.parse(lookahead,lexstream,print_error,())
	end

      fun parse_instream infname ins = 
	 let val lexer = AntAsmParser.makeLexer
                      (fn n => TextIO.inputN(ins,n))
	     val (result,lexer') = invoke infname lexer
	 in result
	 end

      fun parse_file fname = 
	let 
	  val ins = TextIO.openIn fname
	  val brain = parse_instream fname ins
	  val _ = TextIO.closeIn ins
	in brain
	end

  end