
Define NOGO 5
Define GIVEUP 100
	
;; Counts the number of distinct paths through the current node.
;; Jumps to zero_one or two_more facing the same direction,
;; jumps to interest facing the interesting thing.
Func COUNT_PATHS (zero_one, two_more, interest, saw-ant)
    Variable numedges Of (n0 n1 n2ormore) In
	Repeat 5
	  Turn Left .		
	  If Sensing Ahead Friend Goto saw-ant
	  If AnyOf(Sensing Ahead Home
			   Sensing Ahead Food
		       Sensing Ahead FoeHome) Goto interest
	  If AllOf(AnyOf(Sensing LeftAhead Rock
			 Sensing LeftAhead Marker NOGO)
		   Not (AnyOf(Sensing Ahead Rock
			      Sensing Ahead Marker NOGO))) Then
	     Switch numedges Of
		Case n0
		  Assign numedges n1
		Case n1
		  Assign numedges n2ormore
	     End
	  Else End
	End
	Turn Left .

	Switch numedges Of
	Case n0
	  If True Goto zero_one
	Case n1
	  If True Goto zero_one
	Case n2ormore
	  If True Goto two_more
	End
	Abort "impossible"
    End
End


;;; 
;;; Become a Filler ant.
;;; 
Func FILLER (dir1, dir1ahead, dir2, d2ahead)
wander:
	If AnyOf(Sensing Ahead Rock
			 Sensing Ahead Marker NOGO) 
		Goto check-surroundings		
	Move wander .
	Flip 2 rotate-cw rotate-ccw
rotate-cw:
	Turn Right Next
	Flip 2 rotate-cw wander
rotate-ccw:
	Turn Left Next
	Flip 2 rotate-ccw wander

check-surroundings:
	SetName "S" "S"		
	Call COUNT_PATHS (set-nogo-mark, run-away, walk-away, wait-a-bit)
		
set-nogo-mark:
	Repeat 6
		SetName "M" "M"
	    If Not AnyOf(Sensing Ahead Rock
		             Sensing Ahead Marker NOGO) Then
			Mark NOGO follow-wall
		Else
			Turn dir1 .
		End
	End
    If True Goto walk-away	
						
follow-wall:
	Move . wander
	While Not AnyOf(Sensing Ahead Rock
				    Sensing Ahead Marker NOGO) 
		Turn dir2 .
	End
	If True Goto check-surroundings

wait-a-bit:
	Repeat 12 Drop . End
    Turn dir2 wander
		
run-away:
	If (Flip 40) Then
	    Call GET-UNSTUCK()
	Else End		
	Turn dir1 .
	Move . .					; fallthru
walk-away:	
	If Flip GIVEUP Then
		SetName "@" "@"
	Else
		If Flip 8 Then
			Turn dir1 .
		Else End
		If True Goto wander
	End							; fallthru
End




;;  this is a little bad because it changes orientation
;;;  if we're about to hit something
Func GET-UNSTUCK ()
    If Not (AnyOf (Sensing Ahead Marker NOGO
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker NOGO
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker NOGO
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker NOGO
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker NOGO
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker NOGO
		   Sensing Ahead Rock)) Goto unstuck
;;; stuck!

  gstuck-mode:
    If (Sensing Ahead Rock) Then
	If Flip 20 Then
	    Turn Left .
	Else
	    Turn Right .
	End
	If True Goto gstuck-mode
    Else
	Move . .
	If (Sensing Here Marker NOGO) Goto gstuck-mode
        If True Goto unstuck
    End
    
  unstuck:
End

;;;
;;; Become a Bouncer ant, looking for food
;;;
Func BOUNCER ()
  ; A crazy hybrid of kicker and stapler

 If Flip 3 Then

  ;;;  in base:	 no need to avoid marker NOGO
  edge1:
    SetName "!" "?"
    If Sensing RightAhead Home Then
      Move edge1 edge1turn
    Else
  edge1turn:
      Turn Right edge1
    End


 Else

  attack-you:	
      Sense found-base-you no-enemy-base-you Here FoeHome

  ;;;  try to orient ourselves so that we are on the edge,
  ;;;  then walk around it until we are adjacent to a friend
  found-base-you:
  ;;;  might as well pick up their food--it's a free point!
  ;;;  they probably leave it on the edge, anyway. once we get 
  ;;;  critical density, we could perhaps start removing it from
  ;;;  base...
      PickUp Next Next
  try-to-face-cw-you:	
  ;;;  now try to face cw.
      If AllOf(Sensing Ahead FoeHome
	       Not (Sensing LeftAhead FoeHome)) Goto at-base-facing-cw-you
  ;;;  not yet, so turn and try again
      Turn Right try-to-face-cw-you

  ;;; walk around the base, to avoid being killed, and to make space
  ;;; for friends trying to get in
  at-base-facing-cw-you:  
      Move found-base-you at-base-facing-cw-you

  ;;;  keep looking ... 
  no-enemy-base-you:
  ;;;  don't walk onto markerNOGO
      If (Sensing Ahead Marker NOGO) Then
	If (Flip 40) Then
	    Call GET-UNSTUCK()
	Else End
    
    	If True Goto hit-while-attacking-you

      Else End
      Move attack-you hit-while-attacking-you

  hit-while-attacking-you:
  ;;;  see what I hit. if rock, turn:
      If Sensing Ahead Rock Goto turn-away-you
  ;;;  if a friend or foe on base,
  ;;;  just wait for it to move out of the way.
  ;;;  we have priority because of a tight loop.
  ;;;  on the other hand, we may want to sense around
  ;;;  for lots of foes and run if we're about to
  ;;;  be (accidentally) captured
      Sense blocked-at-base-you Next Ahead FoeHome
  ;;;  otherwise, just turn away:	

  turn-away-you:
      Flip 2 arot-cw-you arot-ccw-you
  arot-cw-you:
      Turn Right Next
      Flip 3 arot-cw-you no-enemy-base-you
  arot-ccw-you:
      Turn Left Next
      Flip 3 arot-ccw-you no-enemy-base-you

  ;;; I know I'm facing their base, on non-base
  blocked-at-base-you:
  ;;;  XX randomly decide to go forage. (interval 18 * 30)
      If Flip 540 Goto become-forager
      If AnyOf (Sensing Ahead Foe Sensing Ahead Friend) Goto blocked-at-base-you
  ;;;  XX by invt can go directly to found-base
      Move attack-you blocked-at-base-you






  become-forager:
  ;;; ChangeSymbol F U
  try-to-find-food:
      Sense no-food-here ok-to-try-to-get-food Here Home
  forage:	
  ok-to-try-to-get-food:	
      PickUp got-food no-food-here
  no-food-here:
      If (Sensing Ahead Marker NOGO) Then
	If (Flip 40) Then
	    Call GET-UNSTUCK()
	Else 
	  Call COUNT_PATHS (man-i-hit-something, follow-wall, man-i-hit-something, man-i-hit-something)		
		End

    	If True Goto man-i-hit-something

      Else End
      Move try-to-find-food man-i-hit-something

  man-i-hit-something:
      ;;  try turning in a random direction.
      Flip 2 rotate-cw rotate-ccw

  rotate-cw:
      Turn Right Next
      ;;  maybe keep turning!
      Flip 2 rotate-cw try-to-find-food

  rotate-ccw:
      Turn Left Next
      Flip 2 rotate-ccw try-to-find-food

follow-wall:
	SetName "-" "-"
	While AnyOf(Sensing Ahead Rock
		        Sensing Ahead Marker NOGO)
		Turn Right .
	End
	Move forage rotate-cw

  got-food:
      Turn Left Next
      Turn Left Next
      Turn Left Next
      ;;  try to find base
  have-food:
      If AnyOf(Sensing Ahead Friend Sensing Here Home) Then 
	Drop no-food-here 
      Else 
        If (Sensing Ahead Marker NOGO) Then
	    If (Flip 40) Then
	       Call GET-UNSTUCK()
	    Else End
	    If True Goto fhit-something
	Else End
    	Move have-food fhit-something 
      End


  got-food-no-friend-drop:
      Turn Left Next
      Turn Left Next
      Turn Left Next
      ;;  try to find base
  have-food-no-friend-drop:
      If Sensing Here Home 
      Then Drop no-food-here 
      Else 
        If (Sensing Ahead Marker NOGO) Then
	    If (Flip 40) Then
		  Call GET-UNSTUCK()
	    Else End
	    If True Goto fhit-something
	Else End
        Move have-food-no-friend-drop fhit-something 
      End



  fhit-something:
      Flip 2 frotate-cw frotate-ccw

  frotate-cw:
      Turn Right Next
      Flip 2 frotate-cw have-food

  frotate-ccw:
      Turn Left Next
      Flip 2 frotate-ccw have-food

  fhit-something-no-friend-drop:
      Flip 2 frotate-cw-no-friend-drop frotate-ccw-no-friend-drop

  frotate-cw-no-friend-drop:
      Turn Right Next
      Flip 2 frotate-cw-no-friend-drop have-food-no-friend-drop

  frotate-ccw-no-friend-drop:
      Turn Left Next
      Flip 2 frotate-ccw-no-friend-drop have-food-no-friend-drop

 End
End

		
start:
	SetName "." "."
	If Flip 10 Then
		Call FILLER (Left, LeftAhead, Right, RightAhead)
		Call BOUNCER ()
	Else
		Call BOUNCER ()
	End

