	;;   6 x 4
	;;  x x x x
	;; 5 x x x 1
	;;  x x x x
	;;   3 x 2
start:
	Sense ne-friend Next LeftAhead Friend
	Sense e-friend Next Ahead Friend
	Sense se-friend start-trail RightAhead Friend; false => #1

ne-friend:
	Sense ne-e-friend Next Ahead Friend
	Turn Right Next
	Turn Right Next
	Sense not-a-corner Next RightAhead Friend
	Turn Left start-trail	; #2
	
e-friend:
	Sense e-se-friend Next RightAhead Friend
	Turn Right Next
	Turn Right Next		
	Sense not-a-corner start-trail RightAhead Friend; false => #3

se-friend:	
	Turn Left Next
	Turn Left Next
	Sense not-a-corner Next LeftAhead Friend
	Turn Right Next		; #4

ne-e-friend:
	Turn Left Next
	Sense not-a-corner Next LeftAhead Friend
	Turn Right Next
	Turn Right Next
	Sense not-a-corner Next RightAhead Friend
	Turn Right Next
	Turn Right start-trail	; #5

e-se-friend:			; But no ne-friend
	Turn Left Next
	Turn Left Next
	Sense not-a-corner start-trail LeftAhead Friend; false => #6

	;; 
	;; Make a trail that goes until we find food
	;; 
start-trail:
	Mark 0 Next
	Mark 1 Next
	Move make-trail not-a-corner
	
make-trail:	
	Sense random-walk-to-food Next Here Home
	Sense food-here Next Here Food
	Sense food-ahead Next Ahead Food
	Sense food-left Next LeftAhead Food 
	Sense food-right Next RightAhead Food 
	Flip 10 turn-and-move Next
	Sense start-marker Next Here Marker 0
	Sense start-marker Next Here Marker 1
	Mark 0 Next
	Mark 1 Next
start-marker:		
	Move make-trail blocked
	
food-here:
	PickUp Next follow-path-food
	Sense food-here-marker Next Here Marker 0
	Sense food-here-marker Next Here Marker 1
	Mark 0 Next
	Mark 1 Next
food-here-marker:
	Turn Right Next
	Turn Right Next
	Turn Right follow-path-home

food-ahead:
	Sense food-ahead-marker Next Here Marker 0
	Sense food-ahead-marker Next Here Marker 1
	Mark 0 Next
	Mark 1 Next
food-ahead-marker:
	Move make-trail blocked

food-left:
	Sense food-left-marker Next Here Marker 0
	Sense food-left-marker Next Here Marker 1	
	Mark 0 Next
food-left-marker:
	Turn Left blocked

food-right:
	Sense food-right-marker Next Here Marker 0
	Sense food-right-marker Next Here Marker 1
	Mark 1 Next
food-right-marker:
	Turn Right blocked

turn-and-move:
	Flip 2 Next turn-right-and-move
	Sense turn-left-marker Next Here Marker 0
	Sense turn-left-marker Next Here Marker 1
	Mark 0 Next
turn-left-marker:
	Turn Left Next
	Move make-trail blocked

turn-right-and-move:
	Sense turn-right-marker Next Here Marker 0
	Sense turn-right-marker Next Here Marker 1
	Mark 1 Next
turn-right-marker:
	Turn Right Next
	Move make-trail blocked

blocked:
	Unmark 0 Next
	Unmark 1 follow-path-food

	;; 
	;; We have food and we are going home. Assumes we are on the path.
	;; 
follow-path-home:
	Sense drop-food Next Here Home
	Sense follow-straight-home Next Ahead Home
	Sense go-home-left Next LeftAhead Home
	Sense go-home-right Next RightAhead Home
	Sense Next follow-path-home-else Here Marker 0 ; Left or Straight
	Sense follow-straight-home follow-left-home Here Marker 1	; Straight
follow-path-home-else:	
	Sense follow-right-home random-walk-with-food Here Marker 1 ; Right

drop-food:
	Drop Next
	Turn Right Next
	Turn Right Next
	Turn Right Next
	Move follow-path-food follow-path-food

follow-straight-home:	
	Move follow-path-home blocked-with-food ; if we're blocked, just drop

blocked-with-food:
	Sense drop-food random-walk-with-food Ahead Friend
		
follow-left-home:	
	Sense Next follow-left-home-else RightAhead Marker 0
	Turn Right follow-straight-home
follow-left-home-else:	
	Sense Next reverse-to-home RightAhead Marker 1
	Turn Right follow-straight-home
			
follow-right-home:
	Sense Next follow-right-home-else LeftAhead Marker 0
	Turn Left follow-straight-home
follow-right-home-else:
	Sense Next reverse-to-home LeftAhead Marker 1
	Turn Left follow-straight-home

reverse-to-home:	
	Turn Right Next
	Turn Right Next
	Turn Right follow-straight-home

go-home-left:
	Turn Left follow-straight-home
go-home-right:
	Turn Right follow-straight-home

	;; We have food, but no path -- just random walk
random-walk-with-food:
	Flip 10 move-random-with-food turn-random-with-food

move-random-with-food:
	Move follow-path-home turn-random-with-food

turn-random-with-food:
	Flip 2 turn-left-random-with-food turn-right-random-with-food

turn-left-random-with-food:
	Turn Left follow-path-home

turn-right-random-with-food:
	Turn Right follow-path-home


	;;
	;; Follow a path to food!
follow-path-food:
	Sense food-here Next Here Food
	Sense follow-straight-food Next Ahead Food
	Sense go-to-food-left Next LeftAhead Food
	Sense go-to-food-right Next RightAhead Food
	Sense Next follow-path-food-else Here Marker 0 ; Left or Straight
	Sense follow-straight-food follow-left-food Here Marker 1; Straight
follow-path-food-else:	
	Sense follow-right-food random-walk-with-food Here Marker 1 ; Right

follow-straight-food:
	Move follow-path-food random-walk-to-food ; if we're blocked, just drop

follow-left-food:
	Sense Next follow-left-food-else LeftAhead Marker 0
	Turn Left follow-straight-food
follow-left-food-else:
	Sense Next reverse-to-food LeftAhead Marker 1
	Turn Left follow-straight-food
			
follow-right-food:
	Sense Next follow-right-food-else RightAhead Marker 0
	Turn Right follow-straight-food
follow-right-food-else:
	Sense Next reverse-to-food RightAhead Marker 1
	Turn Right follow-straight-food

reverse-to-food:	
	Turn Right Next
	Turn Right Next
	Turn Right follow-straight-food

go-to-food-left:
	Turn Left follow-straight-food
go-to-food-right:
	Turn Right follow-straight-food

	;;
	;; We need food, but we've lost the trail!
	;; 
random-walk-to-food:	
	Flip 10 move-random-to-food turn-random-to-food

move-random-to-food:
	Move follow-path-food turn-random-to-food

turn-random-to-food:
	Flip 2 turn-left-random-to-food turn-right-random-to-food

turn-left-random-to-food:
	Turn Left follow-path-food

turn-right-random-to-food:
	Turn Right follow-path-food
	
		
not-a-corner:
	;; Wait for a while
	Drop Next	
	Drop Next
	Drop Next
	Drop Next
	Drop Next	
	Drop Next
	Drop Next
	Drop Next
	Drop Next	
	Drop Next
	Drop Next
	Drop Next
	Drop random-walk-to-food

