
;;; dedicate a few ants to filling in the borders of the map.
;;; this shrinks the search space, at the expense of a sense
;;; test.

Func BOUNCER ()
  try-to-find-food:
      Sense no-food-here ok-to-try-to-get-food Here Home
  ok-to-try-to-get-food:	
      PickUp got-food no-food-here
  no-food-here:
      If (Sensing Ahead Marker 5) Goto man-i-hit-something
      Move try-to-find-food man-i-hit-something

  man-i-hit-something:
      ;;  try turning in a random direction.
      Flip 2 rotate-cw rotate-ccw

  rotate-cw:
      Turn Right Next
      ;;  maybe keep turning!
      Flip 2 rotate-cw try-to-find-food

  rotate-ccw:
      Turn Left Next
      Flip 2 rotate-ccw try-to-find-food


  got-food:
      Turn Left Next
      Turn Left Next
      Turn Left Next
      ;;  try to find base
  have-food:
      Sense drop-my-food no-base-here Here Home

  drop-my-food:
      Drop try-to-find-food

  no-base-here:
      If (Sensing Ahead Marker 5) Goto fhit-something
      Move have-food fhit-something

  fhit-something:
      Flip 2 frotate-cw frotate-ccw

  frotate-cw:
      Turn Right Next
      Flip 2 frotate-cw have-food

  frotate-ccw:
      Turn Left Next
      Flip 2 frotate-ccw have-food
End

    
Func TURNAROUND()
    Turn Left .
    Turn Left .
    Turn Left .
End

Func RANDOM-DIR()
    If Flip 6 Goto done
    Turn Left .
    If Flip 5 Goto done
    Turn Left .
    If Flip 4 Goto done
    Turn Left .
    If Flip 3 Goto done
    Turn Left .
    If Flip 2 Goto done
    Turn Left .
done:	
End
    
Func MAYBEMOVE(condy, d, od, l)
    If condy Then
	Turn d .
	Move maybemove_ok maybemove_notok
    Else
	If True Goto mmend
    End
maybemove_ok:
    Turn od .
    Turn od l
maybemove_notok:	
    Turn od l
mmend:	
End

Func GET-OUT()
get-out-of-here:    
    Call RANDOM-DIR()
    ;; find a non-rock location
    If Sensing Ahead Rock Then
	Turn Left get-out-of-here
    Else 
	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    End
End

        
Func STUBBORNMOVE(cond, ll)
tryagain:
    SetName "S" "S"
    Move success .
    If cond Goto ll

    Call MAYBEMOVE(Flip 4, Left, Right, tryagain)
    Call MAYBEMOVE(Flip 4, Right, Left, tryagain)

success:
    SetName "X" "O"
End
    
decide-role:
    If AllOf (Not (Sensing Ahead Home)
	      Not (Sensing LeftAhead Home)
	      Not (Sensing RightAhead Home)) Goto begin_floodfill
;;; turn around.
    Turn Left .
    Turn Left .
    Turn Left .
    If AllOf (Not (Sensing Ahead Home)
	      Not (Sensing LeftAhead Home)
	      Not (Sensing RightAhead Home)) Goto begin_floodfill
;;; otherwise, just a regular dude.

;;; XXX should probably do something!
regular-dude:
    Call BOUNCER()
    If True Goto regular-dude

begin_floodfill:  
Variable orientation Of (cw ccw) In    
  ;;;  XXX this can 'pinch off' areas of
  ;;;  the map and make them inaccessible

  ;;;  the idea of floodfill is to hug,
  ;;   always going counter-clockwise,
  ;;;  permanent objects (mark 5 and rocks)
  ;;;  laying down mark 5 as we go. If we
  ;;;  ever run across something useful, we
  ;;;  stop marking and become a regular dude.

  ;;;  (one idea would be to reserve another mark
  ;;;  for 'good')
  floodfill:
      SetName "F" "W"
      Move try-to-find-obstacle try-to-find-obstacle

  try-to-find-obstacle:
      If AnyOf (Sensing Ahead Rock
		Sensing Ahead Marker 5) Then
	 If AnyOf (Sensing Here Food
		   Sensing Here Home
		   Sensing Here FoeHome) Goto found-cool
	 ;;;  found an obstacle, and we're on clear ground.
	 SetName "E" "E"
	 Mark 5 .
	 Switch orientation Of
	   Case cw
	      Turn Right face-appropriate-edge
	   Case ccw
	      Turn Left face-appropriate-edge
	 End
        
      Else
      ;;;  should do some sort of evasive move. we can be on the
      ;;;  edge where there is food (dropped), or walking against
      ;;   another stubborn ant, etc.
	  Call STUBBORNMOVE(Flip 10, couldnt-move)
	  If True Goto try-to-find-obstacle
      End
  couldnt-move:
      SetName "!" "!"
      Call GET-OUT ()
      If True Goto try-to-find-obstacle

  ;;;  turn so that we have obstacle rightahead and
  ;;;  clear ahead. we know that we just made a mark,
  ;;;  but would have been on clear ground, and that
  ;;;  there is an obstacle rightahead.
  face-appropriate-edge:
  ;;;  if we find something cool on the edge, then turn around.
      If AnyOf (Sensing Ahead Food
		Sensing Ahead Home
		Sensing Ahead FoeHome) Then
	;;;  back up
	Unmark 5 .
    	Call TURNAROUND()
	Move . .
	Unmark 5 .
	Switch orientation Of
	  Case cw
	    Turn Right .
    	    Assign orientation ccw
	  Case ccw
	    Turn Left .
    	    Assign orientation cw
	End
	If True Goto try-to-find-obstacle
      Else End

      If Not (AnyOf (Sensing Ahead Rock
		     Sensing Ahead Marker 5)) Then
	  ;;;  this should also be a stubborn move
	  Move new-edge-cell face-appropriate-edge
      Else
      ;;;  might want to eventually do some evasion here
	  Switch orientation Of
	    Case cw
	      Turn Right face-appropriate-edge
    	    Case ccw
	      Turn Left face-appropriate-edge
	  End
      End

  ;;;  could optimize this, since we know that after two
  ;;;  right turns we'll be facing an obstacle.
  new-edge-cell:
      Switch orientation Of
        Case cw
	  Turn Left .
	  Turn Left try-to-find-obstacle
    	Case ccw
	  Turn Right .
	  Turn Right try-to-find-obstacle
      End
    
  ;;;  should probably become forager.
  found-cool:
      SetName "C" "K"
  looping:
      Drop looping
End

