
;;; Tom's upgraded bouncer robot. There are now attacker and forager
;;; bouncers. Foragers are as before, but attackers try to bounce to
;;; the border of the enemy's base and walk around it.
    
bifurcate:  
;;    Flip 3 attack forage
;;;  this time we always start with attack
     Flip 4 attack-me attack-you

attack-me:	
    Sense found-base-me no-enemy-base-me Here Home

;;;  try to orient ourselves so that we are on the edge,
;;;  then walk around it until we are adjacent to a friend
found-base-me:
;;;  might as well pick up their food--it's a free point!
;;;  they probably leave it on the edge, anyway. once we get 
;;;  critical density, we could perhaps start removing it from
;;;  base...
;     PickUp Next Next
try-to-face-cw-me:	
;;;  now try to face cw.
    If AllOf(Sensing Ahead Home
	     Not (Sensing LeftAhead Home)) Goto at-base-facing-cw-me
;;;  not yet, so turn and try again
    Turn Right try-to-face-cw-me2

try-to-face-cw-me2:	
;;;  now try to face cw.
    If AllOf(Sensing Ahead Home
	     Not (Sensing LeftAhead Home)) Goto at-base-facing-cw-me
;;;  not yet, so turn and try again
    Turn Right try-to-face-cw-me3

try-to-face-cw-me3:	
;;;  now try to face cw.
    If AllOf(Sensing Ahead Home
	     Not (Sensing LeftAhead Home)) Goto at-base-facing-cw-me
;;;  not yet, so move
    Turn Right try-to-face-cw-me4

try-to-face-cw-me4:	
;;;  now try to face cw.
    If AllOf(Sensing Ahead Home
	     Not (Sensing LeftAhead Home)) Goto at-base-facing-cw-me
;;;  not yet, so move
    Turn Right try-to-face-cw-me5


try-to-face-cw-me5:	
;;;  now try to face cw.
    If AllOf(Sensing Ahead Home
	     Not (Sensing LeftAhead Home)) Goto at-base-facing-cw-me
;;;  not yet, so move
    Move forage blocked-at-base-me





	
;;; walk around the base, to avoid being killed, and to make space
;;; for friends trying to get in
at-base-facing-cw-me:  
    Move found-base-me at-base-facing-cw-me
    
;;;  keep looking ... 
no-enemy-base-me:
    Move attack-me hit-while-attacking-me

hit-while-attacking-me:
;;;  see what I hit. if rock, turn:
    If Sensing Ahead Rock Goto turn-away-me
;;;  if a friend or foe on base,
;;;  just wait for it to move out of the way.
;;;  we have priority because of a tight loop.
;;;  on the other hand, we may want to sense around
;;;  for lots of foes and run if we're about to
;;;  be (accidentally) captured
    Sense blocked-at-base-me Next Ahead Home
;;;  otherwise, just turn away:	
    
turn-away-me:
    Flip 2 arot-cw-me arot-ccw-me
arot-cw-me:
    Turn Right Next
    Flip 3 arot-cw-me no-enemy-base-me
arot-ccw-me:
    Turn Left Next
    Flip 3 arot-ccw-me no-enemy-base-me

;;; I know I'm facing their base, on non-base
blocked-at-base-me:
;;;  XX randomly decide to go forage. (interval 18 * 30)
    If Flip 540 Goto become-forager
    If AnyOf (Sensing Ahead Foe Sensing Ahead Friend) Goto blocked-at-base-me
;;;  XX by invt can go directly to found-base
    Move attack-me blocked-at-base-me






attack-you:	
    Sense found-base-you no-enemy-base-you Here FoeHome

;;;  try to orient ourselves so that we are on the edge,
;;;  then walk around it until we are adjacent to a friend
found-base-you:
;;;  might as well pick up their food--it's a free point!
;;;  they probably leave it on the edge, anyway. once we get 
;;;  critical density, we could perhaps start removing it from
;;;  base...
    PickUp Next Next
try-to-face-cw-you:	
;;;  now try to face cw.
    If AllOf(Sensing Ahead FoeHome
	     Not (Sensing LeftAhead FoeHome)) Goto at-base-facing-cw-you
;;;  not yet, so turn and try again
    Turn Right try-to-face-cw-you

;;; walk around the base, to avoid being killed, and to make space
;;; for friends trying to get in
at-base-facing-cw-you:  
    Move found-base-you at-base-facing-cw-you
    
;;;  keep looking ... 
no-enemy-base-you:
    Move attack-you hit-while-attacking-you

hit-while-attacking-you:
;;;  see what I hit. if rock, turn:
    If Sensing Ahead Rock Goto turn-away-you
;;;  if a friend or foe on base,
;;;  just wait for it to move out of the way.
;;;  we have priority because of a tight loop.
;;;  on the other hand, we may want to sense around
;;;  for lots of foes and run if we're about to
;;;  be (accidentally) captured
    Sense blocked-at-base-you Next Ahead FoeHome
;;;  otherwise, just turn away:	
    
turn-away-you:
    Flip 2 arot-cw-you arot-ccw-you
arot-cw-you:
    Turn Right Next
    Flip 3 arot-cw-you no-enemy-base-you
arot-ccw-you:
    Turn Left Next
    Flip 3 arot-ccw-you no-enemy-base-you

;;; I know I'm facing their base, on non-base
blocked-at-base-you:
;;;  XX randomly decide to go forage. (interval 18 * 30)
    If Flip 540 Goto become-forager
    If AnyOf (Sensing Ahead Foe Sensing Ahead Friend) Goto blocked-at-base-you
;;;  XX by invt can go directly to found-base
    Move attack-you blocked-at-base-you




	

become-forager:
;;; ChangeSymbol F U
try-to-find-food:
    Sense no-food-here ok-to-try-to-get-food Here Home
forage:	
ok-to-try-to-get-food:	
    PickUp got-food no-food-here
no-food-here:
    Move try-to-find-food man-i-hit-something

man-i-hit-something:
    ;;  try turning in a random direction.
    Flip 2 rotate-cw rotate-ccw

rotate-cw:
    Turn Right Next
    ;;  maybe keep turning!
    Flip 2 rotate-cw try-to-find-food

rotate-ccw:
    Turn Left Next
    Flip 2 rotate-ccw try-to-find-food


got-food:
    Turn Left Next
    Turn Left Next
    Turn Left Next
    ;;  try to find base
have-food:
    Sense drop-my-food no-base-here Here Home

drop-my-food:
    Drop try-to-find-food
    
no-base-here:
    Move have-food fhit-something

fhit-something:
    Flip 2 frotate-cw frotate-ccw

frotate-cw:
    Turn Right Next
    Flip 2 frotate-cw have-food

frotate-ccw:
    Turn Left Next
    Flip 2 frotate-ccw have-food
