
;;; Tom's upgraded bouncer robot. There are now attacker and forager
;;; bouncers. Foragers are as before, but attackers try to bounce to
;;; the border of the enemy's base and walk around it.
    
bifurcate:  
    Flip 3 attack forage

attack:	
    Sense found-base no-enemy-base Here FoeHome

;;;  try to orient ourselves so that we are on the edge,
;;;  then walk around it until we are adjacent to a friend
found-base:
;;;  might as well pick up their food--it's a free point!
;;;  they probably leave it on the edge, anyway. once we get 
;;;  critical density, we could perhaps start removing it from
;;;  base...
    PickUp Next Next
;;;  will this step keep us on the edge?
    Sense not-edge Next Ahead FoeHome
    Flip 2 try-cw-edge try-ccw-edge

not-edge:
    Turn Left found-base
    
;;;  we know we're in base, and that base is ahead.
;;   is there base to our left?
try-cw-edge:
    Sense no-cw-edge Next LeftAhead FoeHome
;;  Sense Next no-cw-edge Ahead FoeHome
    Move found-base found-base
    
no-cw-edge:
;;;  by invt we *should* eventually find the edge
    Turn Left try-cw-edge

try-ccw-edge:
    Sense no-ccw-edge Next RightAhead FoeHome
    Move found-base found-base

no-ccw-edge:
    Turn Right try-ccw-edge
    
;;;  keep looking ... 
no-enemy-base:
    Move attack hit-while-attacking

hit-while-attacking:
;;;  see what I hit. if rock, turn:
    Sense turn-away Next Ahead Rock
;;;  if a friend or foe on base,
;;;  just wait for it to move out of the way
;;;  we have priority because of a tight loop.
;;;  on the other hand, we may want to sense around
;;;  for lots of foes and run if we're about to
;;;  be (accidentally) captured
    Sense blocked-at-base Next Ahead FoeHome
;;;  otherwise, just turn away:	
    
turn-away:
    Flip 2 arot-cw arot-ccw
arot-cw:
    Turn Right Next
    Flip 3 arot-cw no-enemy-base
arot-ccw:
    Turn Left Next
    Flip 3 arot-ccw no-enemy-base

;;; I know I'm facing their base, on non-base
blocked-at-base:
;;;  XX randomly turn or walk along edge, 
;;   (if it keeps me pointing at base)
    Sense blocked-at-base Next Ahead Foe
    Sense blocked-at-base Next Ahead Friend
    Move found-base blocked-at-base
    
    
try-to-find-food:
    Sense no-food-here ok-to-try-to-get-food Here Home
forage:	
ok-to-try-to-get-food:	
    PickUp got-food no-food-here
no-food-here:
    Move try-to-find-food man-i-hit-something

man-i-hit-something:
    ;;  try turning in a random direction.
    Flip 2 rotate-cw rotate-ccw

rotate-cw:
    Turn Right Next
    ;;  maybe keep turning!
    Flip 2 rotate-cw try-to-find-food

rotate-ccw:
    Turn Left Next
    Flip 2 rotate-ccw try-to-find-food


got-food:
    Turn Left Next
    Turn Left Next
    Turn Left Next
    ;;  try to find base
have-food:
    Sense drop-my-food no-base-here Here Home

drop-my-food:
    Drop try-to-find-food
    
no-base-here:
    Move have-food fhit-something

fhit-something:
    Flip 2 frotate-cw frotate-ccw

frotate-cw:
    Turn Right Next
    Flip 2 frotate-cw have-food

frotate-ccw:
    Turn Left Next
    Flip 2 frotate-ccw have-food
