
;;; Tom's upgraded bouncer robot. There are now attacker and forager
;;; bouncers. Foragers are as before, but attackers try to bounce to
;;; the border of the enemy's base and walk around it.
    
bifurcate:  
;;    Flip 3 attack forage
;;;  this time we always start with attack
     Drop attack

attack:	
    Sense found-base no-enemy-base Here FoeHome

;;;  try to orient ourselves so that we are on the edge,
;;;  then walk around it until we are adjacent to a friend
found-base:
;;;  might as well pick up their food--it's a free point!
;;;  they probably leave it on the edge, anyway. once we get 
;;;  critical density, we could perhaps start removing it from
;;;  base...
    PickUp Next Next
try-to-face-cw:	
;;;  now try to face cw.
    If AllOf(Sensing Ahead FoeHome
	     Not (Sensing LeftAhead FoeHome)) Goto at-base-facing-cw
;;;  not yet, so turn and try again
    Turn Right try-to-face-cw

;;; walk around the base, to avoid being killed, and to make space
;;; for friends trying to get in
at-base-facing-cw:  
    Move found-base at-base-facing-cw
    
;;;  keep looking ... 
no-enemy-base:
    Move attack hit-while-attacking

hit-while-attacking:
;;;  see what I hit. if rock, turn:
    If Sensing Ahead Rock Goto turn-away
;;;  if a friend or foe on base,
;;;  just wait for it to move out of the way.
;;;  we have priority because of a tight loop.
;;;  on the other hand, we may want to sense around
;;;  for lots of foes and run if we're about to
;;;  be (accidentally) captured
    Sense blocked-at-base Next Ahead FoeHome
;;;  otherwise, just turn away:	
    
turn-away:
    Flip 2 arot-cw arot-ccw
arot-cw:
    Turn Right Next
    Flip 3 arot-cw no-enemy-base
arot-ccw:
    Turn Left Next
    Flip 3 arot-ccw no-enemy-base

;;; I know I'm facing their base, on non-base
blocked-at-base:
;;;  XX randomly decide to go forage. (interval 18 * 30)
    If Flip 540 Goto become-forager
    If AnyOf (Sensing Ahead Foe Sensing Ahead Friend) Goto blocked-at-base
;;;  XX by invt can go directly to found-base
    Move attack blocked-at-base


become-forager:
;;; ChangeSymbol F U
try-to-find-food:
    Sense no-food-here ok-to-try-to-get-food Here Home
forage:	
ok-to-try-to-get-food:	
    PickUp got-food no-food-here
no-food-here:
    Move try-to-find-food man-i-hit-something

man-i-hit-something:
    ;;  try turning in a random direction.
    Flip 2 rotate-cw rotate-ccw

rotate-cw:
    Turn Right Next
    ;;  maybe keep turning!
    Flip 2 rotate-cw try-to-find-food

rotate-ccw:
    Turn Left Next
    Flip 2 rotate-ccw try-to-find-food


got-food:
    Turn Left Next
    Turn Left Next
    Turn Left Next
    ;;  try to find base
have-food:
    Sense drop-my-food no-base-here Here Home

drop-my-food:
    Drop try-to-find-food
    
no-base-here:
    Move have-food fhit-something

fhit-something:
    Flip 2 frotate-cw frotate-ccw

frotate-cw:
    Turn Right Next
    Flip 2 frotate-cw have-food

frotate-ccw:
    Turn Left Next
    Flip 2 frotate-ccw have-food
