
;;; Tom's upgraded bouncer robot. There are now attacker and forager
;;; bouncers. Foragers are as before, but attackers try to bounce to
;;; the border of the enemy's base and walk around it.
    
bifurcate:  
;;    Flip 3 attack forage
;;;  this time we always start with attack
     Drop attack

attack:	
    Sense found-base no-enemy-base Here FoeHome

;;;  try to orient ourselves so that we are on the edge,
;;;  then walk around it until we are adjacent to a friend
found-base:
;;;  might as well pick up their food--it's a free point!
;;;  they probably leave it on the edge, anyway. once we get 
;;;  critical density, we could perhaps start removing it from
;;;  base...
    PickUp Next Next
try-to-face-ccw:	
;;;  now try to face cw.
    If AllOf(Sensing Ahead FoeHome
	     Not (Sensing RightAhead FoeHome)) Goto at-base-facing-ccw
;;;  not yet, so turn and try again
    Turn Left try-to-face-ccw

;;; walk around the base, to avoid being killed, and to make space
;;; for friends trying to get in
at-base-facing-ccw:  
    Move found-base at-base-facing-ccw
    
;;;  keep looking ... 
no-enemy-base:
    Move attack hit-while-attacking

hit-while-attacking:
;;;  see what I hit. if rock, turn:
    If Sensing Ahead Rock Goto turn-away
;;;  if a friend or foe on base,
;;;  just wait for it to move out of the way.
;;;  we have priority because of a tight loop.
;;;  on the other hand, we may want to sense around
;;;  for lots of foes and run if we're about to
;;;  be (accidentally) captured
    Sense blocked-at-base Next Ahead FoeHome
;;;  otherwise, just turn away:	
    
turn-away:
    Flip 2 arot-cw arot-ccw
arot-cw:
    Turn Right Next
    Flip 3 arot-ccw no-enemy-base
arot-ccw:
    Turn Left Next
    Flip 3 arot-ccw no-enemy-base

;;; I know I'm facing their base, on non-base
blocked-at-base:
;;;  XX randomly decide to go forage. (interval 18 * 30)
    If Flip 540 Goto become-forager
    If AnyOf (Sensing Ahead Foe Sensing Ahead Friend) Goto blocked-at-base
;;;  XX by invt can go directly to found-base
    Move attack blocked-at-base


become-forager:
;;; ChangeSymbol F U
Flip 3 try-to-find-food Next
Flip 2 goleft goright
goleft:
    Turn Left Next
    Turn Left try-to-find-food 
goright:
    Turn Right Next
    Turn Right try-to-find-food

try-to-find-food:
    Sense no-food-here Next Here Home
    PickUp got-food no-food-here
no-food-here:
    Sense sniff Next Here Marker 0
do-move:
    Move try-to-find-food man-i-hit-something

sniff:
    Sense do-move Next Ahead Marker 0
    Flip 3 do-move Next
    Turn Right sniff

man-i-hit-something:
    ;;  try turning in a random direction.
    Flip 2 rotate-cw rotate-ccw

rotate-cw:
    Turn Right try-to-find-food

rotate-ccw:
    Turn Left try-to-find-food



got-food:
    Turn Left Next
    Turn Left Next
    Turn Left Next
    ;;  try to find base

exc-have-food:
    Sense drop-my-food exc-no-base-here Here Home

exc-no-base-here:
    Mark 0 Next
    Flip 30 no-base-here Next
    Flip 30 so-excited-i-drop-food Next
    Move exc-have-food fhit-something

so-excited-i-drop-food:
    Drop Next
    Turn Left Next
    Turn Left Next
    Turn Left try-to-find-food
   
have-food:
    Sense drop-my-food no-base-here Here Home

drop-my-food:
    Turn Left Next
    Turn Left Next
    Turn Left Next
    Drop try-to-find-food
    
no-base-here:
    Move have-food fhit-something

fhit-something:
    Flip 2 frotate-cw frotate-ccw

frotate-cw:
    Turn Right have-food

frotate-ccw:
    Turn Left have-food
