
(* Implementation of an MD5-compatible hash function.
   Written by Tom 7 in 2001; code in the public domain. *)

signature MD5 =
sig

  (* Perform the MD5 hash function on a message.
     Returns the 128 bit (16 byte) hash.

     recall that string = CharVector.vector.
     The input string may contain non-ascii data,
     the output certainly will. *)

  val md5 : string -> string

  (* read an entire file and md5 it XXX make*)
(*  val md5file : string -> string *)

(* XXX NOT IMPLEMENTED 
  (* RFC 1321 specifies that the input message need not be a
     multiple of 8 bits. This allows you to specify the actual
     bit length of the message. *)

  val md5_advanced : { len : int,
                       msg : string } -> string
*)

  (* convert a binary string to one built of hex digits *)
  val bintohex : string -> string

end
