
structure RSA =
struct

    infix 6 ++ --
    infix 7 divv modd **
    infix 4 << >> <<= >>=
	
    structure N = IntInf

    val op ++ = N.+
    val op ** = N.*
    val op -- = N.-
    val op divv = N.div
    val op modd = N.mod

    val iton = N.fromInt

    val n0 = iton 0
    val n1 = iton 1
    val n2 = iton 2

    fun keygen callback bits =
	let
	    val p = Prime.makeprime callback 50 bits
	    val q = Prime.makeprime callback 50 bits
	    val n = p ** q
	    val e = iton 65537
	    val phi = (p -- n1) ** (q -- n1)
	    val (d, x, y) = Number.euclid(phi, e)
	    val d = if N.<(y,n0) then n1 -- (n2 ** y)
		    else y
	in
	    ((n, e), (n, d))
	end

    (* en/decrypt one block *)

    fun crypt key n msg =
	Number.modexp msg key n

end