
(* Utilities for manipulating files, paths,
   etc. Needs stringutil. *)

signature FSUTIL =
sig
    
    (* splitext "file.0.txt" = ("file.0", "txt") *)
    val splitext : string -> string * string

    (* chdir_excursion s f
       s is a path to a file, either relative or absolute.
       chdirs to the directory holding s for the purpose
       of executing f, and then restores to the previous
       directory. This works even if f raises an exception. 

       f is supplied with the base filename in s, which
       will now be appropriate for calls to "open" *)
    val chdir_excursion : string -> (string -> 'a) -> 'a

end
