
structure FSUtil :> FSUTIL =
struct

    exception FSUtil of string

    fun splitext s =
        StringUtil.rfield (StringUtil.ischar #".") s

    fun chdir_excursion s f =
        let val {arcs, isAbs, vol} = OS.Path.fromString s
        in
            (case rev arcs of
                 nil => raise FSUtil "no file in chdir_excursion"
               (* don't need to move *)
               | [file] => f file
               (* move to dir and come back *)
               | (file::rest) =>
                 let
                     val new = OS.Path.toString 
                                {arcs = rev rest, isAbs=isAbs, vol=vol}
                     val old = OS.FileSys.getDir ()
                 in
                     let in
                         OS.FileSys.chDir new;
                         f file before
                         OS.FileSys.chDir old
                     end handle ex => (OS.FileSys.chDir old; raise ex)
                 end)

        end

end