
structure StreamUtil :> STREAMUTIL =
struct

    (* converts a string to a char stream *)
    (* XXX doesn't need to make list; inefficient *)
    fun stostream s =
        foldr Stream.cons Stream.empty (String.explode s)

    (* convert a file to a char stream *)
    fun ftostream f =
        let
            val ff = BinIO.openIn f

            fun rd () =
                case BinIO.input1 ff of
                    NONE => (BinIO.closeIn ff; 
                             Stream.empty)
                  | SOME c => Stream.lcons(chr (Word8.toInt c), rd)
        in
            Stream.delay rd
        end

    fun ltostream l =
        foldr Stream.cons Stream.empty l

end